﻿Public Class SiteMaster
    Inherits MasterPage
    Private Const AntiXsrfTokenKey As String = "__AntiXsrfToken"
    Private Const AntiXsrfUserNameKey As String = "__AntiXsrfUserName"
    Private _antiXsrfTokenValue As String

    Protected Sub Page_Init(sender As Object, e As EventArgs)
        ' The code below helps to protect against XSRF attacks
        Dim requestCookie = Request.Cookies(AntiXsrfTokenKey)
        Dim requestCookieGuidValue As Guid
        If requestCookie IsNot Nothing AndAlso Guid.TryParse(requestCookie.Value, requestCookieGuidValue) Then
            ' Use the Anti-XSRF token from the cookie
            _antiXsrfTokenValue = requestCookie.Value
            Page.ViewStateUserKey = _antiXsrfTokenValue
        Else
            ' Generate a new Anti-XSRF token and save to the cookie
            _antiXsrfTokenValue = Guid.NewGuid().ToString("N")
            Page.ViewStateUserKey = _antiXsrfTokenValue

            Dim responseCookie = New HttpCookie(AntiXsrfTokenKey) With { _
                 .HttpOnly = True, _
                 .Value = _antiXsrfTokenValue _
            }
            If FormsAuthentication.RequireSSL AndAlso Request.IsSecureConnection Then
                responseCookie.Secure = True
            End If
            Response.Cookies.[Set](responseCookie)
        End If

        AddHandler Page.PreLoad, AddressOf master_Page_PreLoad
    End Sub

    Protected Sub master_Page_PreLoad(sender As Object, e As EventArgs)
        If Not IsPostBack Then
            ' Set Anti-XSRF token
            ViewState(AntiXsrfTokenKey) = Page.ViewStateUserKey
            ViewState(AntiXsrfUserNameKey) = If(Context.User.Identity.Name, [String].Empty)
        Else
            ' Validate the Anti-XSRF token
            If DirectCast(ViewState(AntiXsrfTokenKey), String) <> _antiXsrfTokenValue OrElse DirectCast(ViewState(AntiXsrfUserNameKey), String) <> (If(Context.User.Identity.Name, [String].Empty)) Then
                Throw New InvalidOperationException("Validation of Anti-XSRF token failed.")
            End If
        End If
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        'Ver esta parte para que quede por ROLES, no por usuario, seguir buscando...
        'If Context.User.Identity.Name = " " Then
        'SH_Menus(False)
        'Else
        'SH_Menus(True)
        'End If
        SH_Menus()

    End Sub

    Protected Sub Unnamed_LoggingOut(sender As Object, e As LoginCancelEventArgs)
        Context.GetOwinContext().Authentication.SignOut()
    End Sub

    Protected Sub SH_Menus()
        'Protected Sub SH_Menus(ByVal bol_type As Boolean)
        Select Case Context.User.Identity.Name

            Case Is = "Administrador"
                'mn_acerca.Visible = True
                'mn_contacto.Visible = True
                'mn_principal.Visible = True
                MN_RH.Visible = True
                mn_comprobaciones.Visible = True
                mn_config.Visible = True
                mn_TI.Visible = True

            Case Is = "ana.sanroman"
                MN_RH.Visible = True
                mn_comprobaciones.Visible = False
                mn_config.Visible = False
                mn_TI.Visible = False

            Case Is = ""
                'mn_acerca.Visible = False
                'mn_contacto.Visible = False
                'mn_principal.Visible = False
                MN_RH.Visible = False
                mn_comprobaciones.Visible = False
                mn_config.Visible = False
                mn_TI.Visible = False

        End Select

    End Sub

    'Public Shared Sub showNotification(msg As String)
    'Dim Notifications As New CustomControls.NotificationControl.NotificationControl

    'Notifications.Show(msg)
    'End Sub

End Class